Zum Hauptinhalt springen

Integration mit Vue

DHTMLX Booking lässt sich über eine Single-File-Komponente in Vue 3 integrieren, die das Widget in einem ref'd-Container einbettet. Dieses Handbuch führt Sie durch das Erstellen eines Vue-Projekts, die Installation von Booking und das Rendern des Widgets mit Daten und Events. Die vollständige Referenzimplementierung finden Sie im Vue-Beispiel auf GitHub.

Tipp

Dieses Handbuch setzt Kenntnisse der Vue 3-Grundkonzepte voraus. Eine Einführung finden Sie in der Vue 3-Dokumentation.

Projekt erstellen​

Erstellen Sie zunächst ein Vue-Projekt, bevor Sie die Booking-Integration hinzufügen.

Info

Installieren Sie Node.js, bevor Sie beginnen.

Der folgende Befehl führt das offizielle Vue-Scaffolding-Tool aus:

npm create vue@latest

Der Befehl installiert und führt create-vue aus. Informationen zu den Eingabeaufforderungen und Optionen finden Sie im Vue.js Quick Start. Nennen Sie das Projekt my-vue-booking-app, wenn Sie dazu aufgefordert werden.

Abhängigkeiten installieren​

Wechseln Sie in das Projektverzeichnis.

Der folgende Befehl öffnet den neu erstellten App-Ordner:

cd my-vue-booking-app

Installieren Sie die Abhängigkeiten und starten Sie den Dev-Server mit Ihrem Paketmanager.

Die folgenden Befehle verwenden yarn:

yarn
yarn dev

Die folgenden Befehle verwenden npm:

npm install
npm run dev

Die App läuft auf einem Localhost, zum Beispiel http://localhost:5173.

Booking zur App hinzufügen​

Stoppen Sie den Dev-Server, bevor Sie das Booking-Paket installieren, und erstellen Sie dann eine Vue-Komponente, die das Widget kapselt.

Schritt 1. Paket installieren​

Laden Sie das Booking-Testpaket herunter und folgen Sie den Schritten in der README des Pakets. Die Testversion ist 30 Tage lang aktiv.

Schritt 2. Booking-Komponente erstellen​

Erstellen Sie eine Datei Booking.vue im Verzeichnis src/components/ und führen Sie die folgenden Schritte aus, um das Widget zu verbinden.

Quelldateien importieren​

Importieren Sie die Booking-Klasse und das Stylesheet mit dem Pfad, der Ihrer Distribution entspricht:

  • dhx-booking-package — PRO-Version, aus einem lokalen Ordner installiert
  • @dhx/trial-booking — Testversion

Der folgende Code-Ausschnitt importiert Booking aus dem PRO-Paket:

Booking.vue
<script>
import { Booking } from 'dhx-booking-package';
import 'dhx-booking-package/dist/booking.css';
</script>

Wenn Ihr PRO-Paket minimierte Assets enthält, importieren Sie die CSS-Datei als booking.min.css.

Der folgende Code-Ausschnitt importiert Booking aus dem Testpaket:

Booking.vue
<script>
import { Booking } from '@dhx/trial-booking';
import '@dhx/trial-booking/dist/booking.css';
</script>
Info

Dieses Tutorial verwendet die Testversion von Booking.

Container festlegen und Booking initialisieren​

Deklarieren Sie den Host-Container im Template und instanziieren Sie Booking im mounted()-Hook. Rufen Sie destructor() in unmounted() auf, um das Widget zu entfernen, wenn Vue die Komponente ausblendet.

Der folgende Code-Ausschnitt deklariert eine Booking-Komponente mit einem ref'd-Container und Lifecycle-Hooks:

Booking.vue
<script>
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

export default {
mounted() {
// Booking-Instanz erstellen
this.booking = new Booking(this.$refs.container, {});
},

unmounted() {
this.booking.destructor(); // Booking entfernen
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Styles hinzufügen​

Booking benötigt sowohl das Widget-Stylesheet (oben importiert) als auch einen Container mit definierter Größe. Legen Sie in der Haupt-CSS-Datei des Projekts die volle Höhe für die Seite und den Widget-Container fest.

Der folgende Code-Ausschnitt setzt die volle Höhe für die Seite und den Booking-Container:

main.css
/* Seitenstile — Root-Container #app verwenden */
html,
body,
#app {
height: 100%;
padding: 0;
margin: 0;
}

/* Booking-Container */
.widget {
height: 100%;
}

Daten laden​

Um Kartendaten in Booking zu laden, bereiten Sie einen Datensatz vor, der der Eigenschaft data entspricht. Informationen zum vollständigen Datenformat und zu Ladeszenarien finden Sie im Handbuch Daten laden.

Erstellen Sie eine Datei data.js im Verzeichnis src/.

Der folgende Code-Ausschnitt definiert einen getData()-Helfer, der einen Beispieldatensatz zurückgibt:

data.js
export function getData() {
function getDate(addDays, hoursValue = 0, minutesValue = 0) {
const date = new Date();
const secondsValue = 0; // auf Minuten runden
const msValue = 0;

date.setDate(date.getDate() + addDays);
date.setHours(hoursValue, minutesValue, secondsValue, msValue);

return date.getTime();
}

return [
{
id: "ee828b5d-a034-420c-889b-978840015d6a",
title: "Natalie Tyson",
category: "Therapist",
subtitle: "2 years of experience",
details: "Cleveland Clinic\n9500 Euclid Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/01.jpg",
price: "$35",
review: {
stars: 4,
count: 120
},
slots: [
{
from: 9,
to: 20,
days: [1, 2, 3, 4, 5]
},
{
from: 10,
to: 18,
days: [6, 0]
}
]
},
{
id: "9b037564-77be-429f-b719-eebbe499027a",
title: "Emma Johnson",
category: "Cardiologist",
subtitle: "2 years of experience",
details: "Stanford Health Care\n1468 Madison Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/03.jpg",
price: "$25",
review: {
stars: 5,
count: 10
},
slots: [
{
from: 14,
to: 17,
size: 30,
gap: 10
},
{
from: 12,
to: 19,
size: 50,
gap: 20,
days: [2],
dates: [getDate(0)]
},
{
from: "18:30",
to: 20,
size: 20,
gap: 20,
days: [3, 4, 5]
}
],
usedSlots: [getDate(0, 12), getDate(0, 18)]
},
// ...
];
}

Öffnen Sie App.vue, importieren Sie den Datensatz, stellen Sie ihn über die Option data() bereit und übergeben Sie den Datensatz als Prop an die Komponente <Booking/>.

Der folgende Code-Ausschnitt rendert die Booking-Komponente mit einem data-Prop:

App.vue
<script>
import Booking from "./components/Booking.vue";
import { getData } from "./data";

export default {
components: { Booking },
data() {
const dataset = getData();
return { dataset };
}
};
</script>

<template>
<Booking :data="dataset" />
</template>

Öffnen Sie Booking.vue und leiten Sie das data-Prop an die Booking-Konfiguration weiter.

Der folgende Code-Ausschnitt verbindet das Prop mit dem Booking-Konstruktor:

Booking.vue
<script>
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

export default {
props: ["data"],

mounted() {
this.booking = new Booking(this.$refs.container, {
data: this.data,
// weitere Konfigurationseigenschaften
});
},

unmounted() {
this.booking.destructor();
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Die Booking-Komponente rendert nun mit den geladenen Daten. Um das Widget weiter anzupassen, übergeben Sie zusätzliche Konfigurationseigenschaften. Die vollständige Liste finden Sie in der Übersicht der Eigenschaften.

Events verarbeiten​

Eine Benutzeraktion im Widget löst ein Event aus. Abonnieren Sie ein Event mit booking.api.on(eventName, handler), um auf die Aktion zu reagieren. Die vollständige Liste der Events finden Sie in der Events-Übersicht.

Öffnen Sie Booking.vue und erweitern Sie mounted() um ein Event-Abonnement.

Der folgende Code-Ausschnitt protokolliert die Slot-ID, wenn ein Benutzer einen Slot auswählt:

Booking.vue
<script>
// ...
export default {
// ...
mounted() {
this.booking = new Booking(this.$refs.container, {});

// ID des ausgewählten Slots protokollieren
this.booking.api.on("select-slot", (obj) => {
console.log(obj.id);
});
}
// ...
}
</script>

<!--...*/}

Starten Sie die App, um Booking mit Daten auf der Seite zu sehen.

DHTMLX Booking-Widget mit geladenen Daten in einer Vue-Anwendung

Passen Sie den Code an Ihre Projektanforderungen an. Die vollständige Referenzimplementierung ist auf GitHub verfügbar.

Zum Hauptinhalt springen

Integration mit React

DHTMLX Booking lässt sich über eine Wrapper-Komponente in React integrieren, die das Widget innerhalb eines Containers mit ref einbindet. Diese Anleitung führt Sie durch das Erstellen eines React-Projekts, die Installation von Booking und das Rendern des Widgets mit Daten und Events. Die vollständige Referenzimplementierung finden Sie im React-Beispiel auf GitHub.

Tipp

Diese Anleitung setzt Kenntnisse der grundlegenden React-Konzepte voraus. Eine Einführung finden Sie in der React-Dokumentation.

Projekt erstellen​

Erstellen Sie zunächst eine React-App, bevor Sie die Booking-Integration hinzufügen. Verwenden Sie dazu entweder Create React App oder React mit Vite.

Info

Installieren Sie Vite (optional) und Node.js bevor Sie beginnen.

Der folgende Befehl erstellt ein neues Projekt my-react-booking-app mit Create React App:

npx create-react-app my-react-booking-app

Abhängigkeiten installieren​

Wechseln Sie in das Projektverzeichnis.

Der folgende Befehl öffnet den neu erstellten App-Ordner:

cd my-react-booking-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit Ihrem Paketmanager.

Die folgenden Befehle verwenden yarn:

yarn
yarn start

Die folgenden Befehle verwenden npm:

npm install
npm start

Die App läuft auf einem Localhost, zum Beispiel http://localhost:3000.

Booking zur App hinzufügen​

Stoppen Sie den Entwicklungsserver, bevor Sie das Booking-Paket installieren, und erstellen Sie dann eine React-Komponente, die das Widget umschließt.

Schritt 1. Paket installieren​

Laden Sie das Test-Booking-Paket herunter und folgen Sie den Schritten in der README des Pakets. Die Testversion bleibt 30 Tage lang aktiv.

Schritt 2. Booking-Komponente erstellen​

Erstellen Sie eine Booking.jsx-Datei im Verzeichnis src/ und führen Sie die folgenden Schritte aus, um das Widget zu verdrahten.

Quelldateien importieren​

Importieren Sie die Booking-Klasse und das Stylesheet mit dem Pfad, der Ihrer Distribution entspricht:

  • dhx-booking-package — PRO-Version, die aus einem lokalen Ordner installiert wurde
  • @dhx/trial-booking — Testversion

Der folgende Code-Ausschnitt importiert Booking aus dem PRO-Paket:

Booking.jsx
import { Booking } from 'dhx-booking-package';
import 'dhx-booking-package/dist/booking.css';

Wenn Ihr PRO-Paket minifizierte Assets enthält, importieren Sie die CSS-Datei als booking.min.css.

Der folgende Code-Ausschnitt importiert Booking aus dem Test-Paket:

Booking.jsx
import { Booking } from '@dhx/trial-booking';
import "@dhx/trial-booking/dist/booking.css";
Info

Dieses Tutorial verwendet die Testversion von Booking.

Container festlegen und Booking initialisieren​

Deklarieren Sie eine ref für den Host-Container und instanziieren Sie Booking innerhalb von useEffect(). Geben Sie eine Bereinigungsfunktion zurück, die destructor() aufruft, um das Widget zu entladen, wenn React die Komponente aushängt.

Der folgende Code-Ausschnitt deklariert eine Booking-Komponente mit einem Container mit ref und Lifecycle-Bereinigung:

Booking.jsx
import { useEffect, useRef } from "react";
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css"; // Booking-Styles importieren

export default function BookingComponent(props) {
let container = useRef(); // Host-Container für Booking

useEffect(() => {
// Booking-Instanz erstellen
const booking = new Booking(container.current, {});

return () => {
booking.destructor(); // Booking entladen
};
}, []);

return <div ref={container} className="widget"></div>;
}

Styles hinzufügen​

Booking benötigt sowohl das Widget-Stylesheet (oben importiert) als auch einen Container mit festgelegter Größe. Setzen Sie in der Haupt-CSS-Datei des Projekts die volle Höhe für die Seite und den Widget-Container.

Der folgende Code-Ausschnitt setzt die volle Höhe für die Seite und den Booking-Container:

index.css
/* Seitengestaltung */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* Booking-Container */
.widget {
height: 100%;
}

Daten laden​

Um Kartendaten in Booking zu laden, bereiten Sie einen Datensatz vor, der der data-Eigenschaft entspricht. Das vollständige Datenformat und Ladeszenarien finden Sie in der Anleitung Daten laden.

Erstellen Sie eine data.js-Datei im Verzeichnis src/.

Der folgende Code-Ausschnitt definiert einen getData()-Helfer, der einen Beispieldatensatz zurückgibt:

data.js
export function getData() {
function getDate(addDays, hoursValue = 0, minutesValue = 0) {
const date = new Date();
const secondsValue = 0; // auf Minuten runden
const msValue = 0;

date.setDate(date.getDate() + addDays);
date.setHours(hoursValue, minutesValue, secondsValue, msValue);

return date.getTime();
}

return [
{
id: "ee828b5d-a034-420c-889b-978840015d6a",
title: "Natalie Tyson",
category: "Therapist",
subtitle: "2 years of experience",
details: "Cleveland Clinic\n9500 Euclid Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/01.jpg",
price: "$35",
review: {
stars: 4,
count: 120
},
slots: [
{
from: 9,
to: 20,
days: [1, 2, 3, 4, 5]
},
{
from: 10,
to: 18,
days: [6, 0]
}
]
},
{
id: "9b037564-77be-429f-b719-eebbe499027a",
title: "Emma Johnson",
category: "Cardiologist",
subtitle: "2 years of experience",
details: "Stanford Health Care\n1468 Madison Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/03.jpg",
price: "$25",
review: {
stars: 5,
count: 10
},
slots: [
{
from: 14,
to: 17,
size: 30,
gap: 10
},
{
from: 12,
to: 19,
size: 50,
gap: 20,
days: [2],
dates: [getDate(0)]
},
{
from: "18:30",
to: 20,
size: 20,
gap: 20,
days: [3, 4, 5]
}
],
usedSlots: [getDate(0, 12), getDate(0, 18)]
},
// ...
];
}

Öffnen Sie App.js, importieren Sie den Datensatz und übergeben Sie ihn als Prop an die <Booking/>-Komponente.

Der folgende Code-Ausschnitt rendert die Booking-Komponente mit einem data-Prop:

App.js
import Booking from "./Booking";
import { getData } from "./data";

function App() {
const dataset = getData();
return <Booking data={dataset} />;
}

export default App;

Öffnen Sie Booking.jsx und leiten Sie das data-Prop an die Booking-Konfiguration weiter.

Der folgende Code-Ausschnitt verdrahtet das Prop mit dem Booking-Konstruktor:

Booking.jsx
import { useEffect, useRef } from "react";
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

export default function BookingComponent(props) {
let container = useRef();

useEffect(() => {
const booking = new Booking(container.current, {
data: props.data
// weitere Konfigurationseigenschaften
});

return () => {
booking.destructor();
}
}, []);

return <div ref={container} className="widget"></div>;
}

Die Booking-Komponente rendert nun mit den geladenen Daten. Um das Widget weiter anzupassen, übergeben Sie zusätzliche Konfigurationseigenschaften. Die vollständige Liste finden Sie in der Eigenschaften-Übersicht.

Events behandeln​

Eine Benutzeraktion im Widget löst ein Event aus. Abonnieren Sie ein Event mit booking.api.on(eventName, handler), um auf die Aktion zu reagieren. Die vollständige Liste der Events finden Sie in der Events-Übersicht.

Öffnen Sie Booking.jsx und erweitern Sie useEffect() um ein Event-Abonnement.

Der folgende Code-Ausschnitt protokolliert die Slot-ID, wenn ein Benutzer einen Slot auswählt:

Booking.jsx
// ...
useEffect(() => {
const booking = new Booking(container.current, {});

// ausgewählte Slot-ID protokollieren
booking.api.on("select-slot", (obj) => {
console.log(obj.id);
});

return () => {
booking.destructor();
}
}, []);
// ...

Starten Sie die App, um Booking mit den Daten auf der Seite zu sehen.

DHTMLX Booking-Widget mit geladenen Daten in einer React-Anwendung

Passen Sie den Code an Ihre Projektanforderungen an. Die vollständige Referenzimplementierung ist auf GitHub verfügbar.

Zum Hauptinhalt springen

Integration mit Svelte

DHTMLX Booking lässt sich über eine Single-File-Komponente in Svelte integrieren, die das Widget in einem gebundenen Container einbindet. Dieses Handbuch führt Sie durch das Erstellen eines Svelte-Projekts, die Installation von Booking und das Rendern des Widgets mit Daten und Events. Die vollständige Referenzimplementierung finden Sie im Svelte-Beispiel auf GitHub.

Tipp

Dieses Handbuch setzt Kenntnisse der grundlegenden Svelte-Konzepte voraus. Eine Einführung finden Sie in der Svelte-Dokumentation.

Projekt erstellen​

Erstellen Sie zunächst ein Svelte-Projekt, bevor Sie die Booking-Integration hinzufügen.

Info

Installieren Sie Vite (optional) und Node.js, bevor Sie beginnen.

Der folgende Befehl startet das Vite-Scaffolding-Tool:

npm create vite@latest

Benennen Sie das Projekt auf Aufforderung my-svelte-booking-app.

Abhängigkeiten installieren​

Wechseln Sie in das Projektverzeichnis.

Der folgende Befehl öffnet den neu erstellten App-Ordner:

cd my-svelte-booking-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit Ihrem Paketmanager.

Die folgenden Befehle verwenden yarn:

yarn
yarn dev

Die folgenden Befehle verwenden npm:

npm install
npm run dev

Die App läuft auf einem Localhost, zum Beispiel http://localhost:5173.

Booking zur App hinzufügen​

Stoppen Sie den Entwicklungsserver, bevor Sie das Booking-Paket installieren, und erstellen Sie dann eine Svelte-Komponente, die das Widget kapselt.

Schritt 1. Paket installieren​

Laden Sie das Booking-Testpaket herunter und folgen Sie den Schritten in der README des Pakets. Die Testversion ist 30 Tage lang gültig.

Schritt 2. Booking-Komponente erstellen​

Erstellen Sie eine Datei Booking.svelte im Verzeichnis src/ und führen Sie die folgenden Schritte aus, um das Widget zu verbinden.

Quelldateien importieren​

Importieren Sie die Booking-Klasse und das Stylesheet mit dem Pfad, der Ihrer Distribution entspricht:

  • dhx-booking-package — PRO-Version, die aus einem lokalen Ordner installiert wurde
  • @dhx/trial-booking — Testversion

Das folgende Code-Snippet importiert Booking aus dem PRO-Paket:

Booking.svelte
<script>
import { Booking } from 'dhx-booking-package';
import 'dhx-booking-package/dist/booking.css';
</script>

Wenn Ihr PRO-Paket minimierte Assets enthält, importieren Sie die CSS-Datei als booking.min.css.

Das folgende Code-Snippet importiert Booking aus dem Testpaket:

Booking.svelte
<script>
import { Booking } from '@dhx/trial-booking';
import '@dhx/trial-booking/dist/booking.css';
</script>
Info

Dieses Tutorial verwendet die Testversion von Booking.

Container festlegen und Booking initialisieren​

Binden Sie den Host-Container mit bind:this und instanziieren Sie Booking innerhalb von onMount(). Rufen Sie destructor() in onDestroy() auf, um das Widget zu entfernen, wenn Svelte die Komponente entlädt.

Das folgende Code-Snippet deklariert eine Booking-Komponente mit einem gebundenen Container und Lifecycle-Hooks:

Booking.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

let container; // Host-Container für Booking
let booking;

onMount(() => {
// Booking-Instanz erstellen
booking = new Booking(container, {})
});

onDestroy(() => {
booking.destructor(); // Booking entfernen
});
</script>

<div bind:this={container} class="widget"></div>

Styles hinzufügen​

Booking benötigt sowohl das Widget-Stylesheet (oben importiert) als auch einen Container mit definierten Abmessungen. Setzen Sie die volle Höhe für die Seite und den Widget-Container in der Haupt-CSS-Datei des Projekts.

Das folgende Code-Snippet setzt die volle Höhe für die Seite und den Booking-Container:

main.css
/* Seitenstile; verwenden Sie den #app-Root-Container */
html,
body,
#app {
height: 100%;
padding: 0;
margin: 0;
}

/* Booking-Container */
.widget {
height: 100%;
}

Daten laden​

Um Kartendaten in Booking zu laden, bereiten Sie einen Datensatz vor, der der Eigenschaft data entspricht. Das vollständige Datenformat und Ladeszenarien finden Sie im Handbuch Daten laden.

Erstellen Sie eine Datei data.js im Verzeichnis src/.

Das folgende Code-Snippet definiert einen getData()-Helfer, der einen Beispieldatensatz zurückgibt:

data.js
export function getData() {
function getDate(addDays, hoursValue = 0, minutesValue = 0) {
const date = new Date();
const secondsValue = 0; // auf Minuten runden
const msValue = 0;

date.setDate(date.getDate() + addDays);
date.setHours(hoursValue, minutesValue, secondsValue, msValue);

return date.getTime();
}

return [
{
id: "ee828b5d-a034-420c-889b-978840015d6a",
title: "Natalie Tyson",
category: "Therapist",
subtitle: "2 years of experience",
details: "Cleveland Clinic\n9500 Euclid Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/01.jpg",
price: "$35",
review: {
stars: 4,
count: 120
},
slots: [
{
from: 9,
to: 20,
days: [1, 2, 3, 4, 5]
},
{
from: 10,
to: 18,
days: [6, 0]
}
]
},
{
id: "9b037564-77be-429f-b719-eebbe499027a",
title: "Emma Johnson",
category: "Cardiologist",
subtitle: "2 years of experience",
details: "Stanford Health Care\n1468 Madison Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/03.jpg",
price: "$25",
review: {
stars: 5,
count: 10
},
slots: [
{
from: 14,
to: 17,
size: 30,
gap: 10
},
{
from: 12,
to: 19,
size: 50,
gap: 20,
days: [2],
dates: [getDate(0)]
},
{
from: "18:30",
to: 20,
size: 20,
gap: 20,
days: [3, 4, 5]
}
],
usedSlots: [getDate(0, 12), getDate(0, 18)]
},
// ...
];
}

Öffnen Sie App.svelte, importieren Sie den Datensatz und übergeben Sie ihn als Prop an die <Booking/>-Komponente.

Das folgende Code-Snippet rendert die Booking-Komponente mit einem data-Prop:

App.svelte
<script>
import Booking from "./Booking.svelte";
import { getData } from "./data.js";

const dataset = getData();
</script>

<Booking data={dataset} />

Öffnen Sie Booking.svelte und leiten Sie den data-Prop an die Booking-Konfiguration weiter.

Das folgende Code-Snippet verdrahtet den Prop mit dem Booking-Konstruktor:

Booking.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Booking } from "@dhx/trial-booking";
import "@dhx/trial-booking/dist/booking.css";

export let data;

let container;
let booking;

onMount(() => {
booking = new Booking(container, {
data
})
});

onDestroy(() => {
booking.destructor();
});
</script>

<div bind:this={container} class="widget"></div>

Die Booking-Komponente rendert nun mit den geladenen Daten. Um das Widget weiter anzupassen, übergeben Sie zusätzliche Konfigurationseigenschaften. Die vollständige Liste finden Sie in der Übersicht der Eigenschaften.

Events verarbeiten​

Eine Benutzeraktion im Widget löst ein Event aus. Abonnieren Sie ein Event mit booking.api.on(eventName, handler), um auf die Aktion zu reagieren. Die vollständige Liste der Events finden Sie in der Übersicht der Events.

Öffnen Sie Booking.svelte und erweitern Sie onMount() um ein Event-Abonnement.

Das folgende Code-Snippet protokolliert die Slot-ID, wenn ein Benutzer einen Slot auswählt:

Booking.svelte
<script>
// ...
let booking;

onMount(() => {
booking = new Booking(container, {})

// ausgewählte Slot-ID protokollieren
booking.api.on("select-slot", (obj) => {
console.log(obj.id);
});
});

onDestroy(() => {
booking.destructor();
});
</script>

// ...

Starten Sie die App, um Booking mit Daten auf der Seite zu sehen.

DHTMLX Booking-Widget mit geladenen Daten in einer Svelte-Anwendung

Passen Sie den Code an Ihre Projektanforderungen an. Die vollständige Referenzimplementierung ist auf GitHub verfügbar.

Zum Hauptinhalt springen

Integration mit Angular

DHTMLX Booking lässt sich über eine benutzerdefinierte Komponente, die den Widget-Konstruktor kapselt, in Angular integrieren. Dieser Leitfaden führt Sie durch das Erstellen eines neuen Angular-Projekts, die Installation von Booking und das Rendern des Widgets mit Daten und Events. Die vollständige Referenzimplementierung finden Sie im Angular-Beispiel auf GitHub.

Tipp

Dieser Leitfaden setzt Grundkenntnisse der Angular-Kernkonzepte voraus. Eine Einführung finden Sie in der Angular-Dokumentation.

Projekt erstellen​

Erstellen Sie mit der Angular CLI ein neues Angular-Projekt, bevor Sie die Booking-Integration hinzufügen.

Info

Installieren Sie Angular CLI und Node.js, bevor Sie beginnen.

Der folgende Befehl erstellt ein neues Projekt namens my-angular-booking-app:

ng new my-angular-booking-app
Hinweis

Deaktivieren Sie Server-Side Rendering (SSR) und Static Site Generation (SSG/Prerendering), wenn Sie die CLI dazu auffordert. Das Booking-Widget wird clientseitig in das DOM eingehängt.

Der Befehl installiert alle erforderlichen Tools. Weitere Befehle sind nicht notwendig.

Abhängigkeiten installieren​

Wechseln Sie in das Projektverzeichnis.

Der folgende Befehl öffnet den neu erstellten App-Ordner:

cd my-angular-booking-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit Ihrem Paketmanager.

Die folgenden Befehle verwenden yarn:

yarn
yarn start

Die folgenden Befehle verwenden npm:

npm install
npm start

Die App läuft auf einem Localhost, zum Beispiel http://localhost:4200.

Booking zur App hinzufügen​

Stoppen Sie den Entwicklungsserver, bevor Sie das Booking-Paket installieren, und erstellen Sie dann eine Angular-Komponente, die das Widget kapselt.

Schritt 1. Paket installieren​

Laden Sie das Booking-Testpaket herunter und folgen Sie den Schritten in der README des Pakets. Die Testversion ist 30 Tage lang aktiv.

Schritt 2. Booking-Komponente erstellen​

Erstellen Sie im Verzeichnis src/app/ einen Ordner namens booking und fügen Sie darin eine Datei booking.component.ts hinzu. Führen Sie die folgenden Schritte aus, um das Widget zu verdrahten.

Quelldateien importieren​

Importieren Sie die Booking-Klasse mit dem Pfad, der Ihrer Distribution entspricht:

  • dhx-booking-package — PRO-Version, aus einem lokalen Ordner installiert
  • @dhx/trial-booking — Testversion

Das folgende Code-Snippet importiert Booking aus dem PRO-Paket:

import { Booking } from 'dhx-booking-package';

Das folgende Code-Snippet importiert Booking aus dem Testpaket:

import { Booking } from '@dhx/trial-booking';
Info

Dieses Tutorial verwendet die Testversion von Booking.

Container festlegen und Booking initialisieren​

Definieren Sie den Host-Container im Komponenten-Template und instanziieren Sie Booking in ngOnInit(). Rufen Sie destructor() in ngOnDestroy() auf, um das Widget zu entfernen, wenn Angular die Komponente zerstört.

Das folgende Code-Snippet deklariert eine Booking-Komponente mit einem Container-Element und Lifecycle-Hooks:

booking.component.ts
import { Booking } from '@dhx/trial-booking';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "booking", // wird in app.component.ts als <booking /> verwendet
styleUrls: ["./booking.component.css"],
template: `<div #container className="widget"></div>`,
})

export class BookingComponent implements OnInit, OnDestroy {
// Host-Container für Booking
@ViewChild('container', { static: true }) booking_container!: ElementRef;

private _booking!: Booking;

ngOnInit() {
// Booking-Instanz erstellen
this._booking = new Booking(this.booking_container.nativeElement, {});
}

ngOnDestroy(): void {
this._booking.destructor(); // Booking entfernen
}
}

Styles hinzufügen​

Booking benötigt sowohl das Widget-Stylesheet als auch einen Container mit festgelegter Höhe.

Erstellen Sie im Verzeichnis src/app/booking/ eine Datei booking.component.css.

Das folgende Code-Snippet importiert das Booking-Stylesheet und setzt die volle Höhe für die Seite und den Widget-Container:

booking.component.css
/* Booking-Styles importieren */
@import "@dhx/trial-booking/dist/booking.css";

/* Seitenstile */
html,
body {
margin: 0;
padding: 0;
height: 100%;
}

/* Booking-Container */
.widget {
height: 100%;
}

Daten laden​

Um Kartendaten in Booking zu laden, bereiten Sie einen Datensatz vor, der der Eigenschaft data entspricht. Das vollständige Datenformat und Ladeszenarien finden Sie im Leitfaden Daten laden.

Erstellen Sie im Verzeichnis src/app/booking/ eine Datei data.ts.

Das folgende Code-Snippet definiert einen getData()-Helfer, der einen Beispieldatensatz zurückgibt:

data.ts
export function getData() : any {
function getDate(addDays : any, hoursValue = 0, minutesValue = 0) {
const date = new Date();
const secondsValue = 0; // auf Minuten runden
const msValue = 0;

date.setDate(date.getDate() + addDays);
date.setHours(hoursValue, minutesValue, secondsValue, msValue);

return date.getTime();
}

return [
{
id: "ee828b5d-a034-420c-889b-978840015d6a",
title: "Natalie Tyson",
category: "Therapist",
subtitle: "2 years of experience",
details: "Cleveland Clinic\n9500 Euclid Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/01.jpg",
price: "$35",
review: {
stars: 4,
count: 120
},
slots: [
{
from: 9,
to: 20,
days: [1, 2, 3, 4, 5]
},
{
from: 10,
to: 18,
days: [6, 0]
}
]
},
{
id: "9b037564-77be-429f-b719-eebbe499027a",
title: "Emma Johnson",
category: "Cardiologist",
subtitle: "2 years of experience",
details: "Stanford Health Care\n1468 Madison Ave",
preview: "https://snippet.dhtmlx.com/codebase/data/booking/01/img/03.jpg",
price: "$25",
review: {
stars: 5,
count: 10
},
slots: [
{
from: 14,
to: 17,
size: 30,
gap: 10
},
{
from: 12,
to: 19,
size: 50,
gap: 20,
days: [2],
dates: [getDate(0)]
},
{
from: "18:30",
to: 20,
size: 20,
gap: 20,
days: [3, 4, 5]
},
],
usedSlots: [getDate(0, 12), getDate(0, 18)]
},
// ...
];
}

Öffnen Sie booking.component.ts, importieren Sie den Datensatz und übergeben Sie ihn in ngOnInit() an die Booking-Konfiguration.

Das folgende Code-Snippet verdrahtet getData() mit dem Booking-Konstruktor:

booking.component.ts
import { Booking } from '@dhx/trial-booking';
import { getData } from "./data"; // Daten importieren
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "booking",
styleUrls: ["./booking.component.css"],
template: `<div #container className="widget"></div>`,
})

export class BookingComponent implements OnInit, OnDestroy {
@ViewChild('container', { static: true }) booking_container!: ElementRef;

private _booking!: Booking;

ngOnInit() {
const data = getData(); // Datensatz laden
this._booking = new Booking(this.booking_container.nativeElement, {
data
});
}

ngOnDestroy(): void {
this._booking.destructor();
}
}

Die Booking-Komponente rendert nun mit den geladenen Daten. Um das Widget weiter anzupassen, übergeben Sie zusätzliche Konfigurationseigenschaften. Die vollständige Liste finden Sie in der Eigenschaftenübersicht.

Events verarbeiten​

Eine Benutzeraktion im Widget löst ein Event aus. Abonnieren Sie ein Event mit booking.api.on(eventName, handler), um auf die Aktion zu reagieren. Die vollständige Liste der Events finden Sie in der Events-Übersicht.

Öffnen Sie booking.component.ts und erweitern Sie ngOnInit() um ein Event-Abonnement.

Das folgende Code-Snippet protokolliert die Slot-ID, wenn ein Benutzer einen Slot auswählt:

booking.component.ts
// ...
ngOnInit() {
this._booking = new Booking(this.booking_container.nativeElement, {
start: new Date(2024, 5, 10),
});

// ID des ausgewählten Slots protokollieren
this._booking.api.on("select-slot", (obj) => {
console.log(obj.id);
});
}

ngOnDestroy(): void {
this._booking.destructor();
}

Schritt 3. Booking in der App registrieren​

Fügen Sie BookingComponent zum Anwendungs-Bootstrap hinzu. Öffnen Sie src/app/app.component.ts und ersetzen Sie den Standardcode.

Das folgende Code-Snippet rendert die Booking-Komponente innerhalb von AppComponent:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<booking/>` // Template definiert in booking.component.ts
})
export class AppComponent {
name = "";
}

Erstellen Sie app.module.ts in src/app/ und deklarieren Sie beide Komponenten.

Das folgende Code-Snippet registriert AppComponent und BookingComponent im Root-Modul:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { BookingComponent } from "./booking/booking.component";

@NgModule({
declarations: [AppComponent, BookingComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Öffnen Sie src/main.ts und starten Sie das Root-Modul.

Das folgende Code-Snippet startet die Anwendung mit AppModule:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

Starten Sie die App, um Booking mit geladenen Daten auf der Seite anzuzeigen.

DHTMLX Booking-Widget mit geladenen Daten in einer Angular-Anwendung

Passen Sie den Code an Ihre Projektanforderungen an. Die vollständige Referenzimplementierung ist auf GitHub verfügbar.